package com.ruoyi.info.order.enums;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.ruoyi.common.enums.IIntegerEnum;

import java.util.Objects;

public enum PayMethod implements IIntegerEnum<Integer> {

    wx(1, "微信"),
    ;

    PayMethod(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    @EnumValue
    @JsonValue
    private Integer code;

    private String msg;

    @Override
    public Integer getCode() {
        return code;
    }

    public void setCode(Integer code) {
        this.code = code;
    }

    @Override
    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    @JsonCreator
    public static PayMethod getByCode(Integer code) {
        for (PayMethod value : PayMethod.values()) {
            if (Objects.equals(code, value.getCode())) {
                return value;
            }
        }
        return null;
    }

    //转成jsonarray
    public static JSONArray toJsonArray() {
        JSONArray jsonArray = new JSONArray();
        for (PayMethod value : PayMethod.values()) {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("code", value.getCode());
            jsonObject.put("value", value.getMsg());
            jsonArray.add(jsonObject);
        }
        return jsonArray;
    }

}
